# Copyright 2019 QuantRocket LLC - All Rights Reserved
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Features
# - for local deployment
# - includes all services
# - pinned to the current production versions
# - sends anonymous crash reports. To disable, edit flightlog
#   env to: SEND_CRASH_REPORTS: 'false'
# - sends anonymous basic usage (houston HTTP access logs). To disable,
#   edit logspout command to: 'syslog+udp://flightlog:9021'

x-quantrocket-version: '1.6.1'
x-quantrocket-deploy-target: 'local'
version: '2.4' # Docker Compose file version
volumes:
  codeload:
  db:
  flightlog:
  settings:
  zipline:
services:
  account:
    image: 'quantrocket/account:1.6.0'
    volumes:
      - 'db:/var/lib/quantrocket'
    depends_on:
      - db
    restart: always
  blotter:
    image: 'quantrocket/blotter:1.6.0'
    volumes:
      - 'db:/var/lib/quantrocket'
    depends_on:
      - db
    restart: always
  codeload:
    image: 'quantrocket/codeload:1.6.0'
    environment:
      GIT_URL: 'https://github.com/quantrocket-codeload/quickstart.git'
      GIT_BRANCH: master
    volumes:
      - 'codeload:/codeload'
    restart: always
  countdown:
    image: 'quantrocket/countdown:1.6.0'
    volumes:
      - 'settings:/etc/opt/quantrocket'
      - 'codeload:/codeload'
    restart: always
  db:
    image: 'quantrocket/db:1.6.0'
    volumes:
      - 'db:/var/lib/quantrocket'
      - 'settings:/etc/opt/quantrocket'
    restart: always
  flightlog:
    image: 'quantrocket/flightlog:1.6.0'
    volumes:
      - 'flightlog:/var/log/flightlog'
      - 'settings:/etc/opt/quantrocket'
    restart: always
    environment:
      SEND_CRASH_REPORTS: 'true'
  fundamental:
    image: 'quantrocket/fundamental:1.6.0'
    volumes:
      - 'db:/var/lib/quantrocket'
    depends_on:
      - db
    restart: always
  history:
    image: 'quantrocket/history:1.6.0'
    volumes:
      - 'db:/var/lib/quantrocket'
      - 'codeload:/codeload'
    depends_on:
      - db
    restart: always
  houston:
    image: 'quantrocket/houston:1.6.0'
    ports:
      - '1969:80'
    restart: always
  ibg1:
    image: 'quantrocket/ibg:1.6.972.0'
    environment:
      INI_SETTINGS: '--ExistingSessionDetectedAction=primary'
      API_SETTINGS: '--readOnlyApi=false --masterClientID=6000 --exposeEntireTradingSchedule=true'
    volumes:
      - 'settings:/etc/opt/quantrocket'
    restart: always
  jupyter:
    image: 'quantrocket/jupyter:1.6.0'
    volumes:
      - 'codeload:/codeload'
      - 'db:/var/lib/quantrocket'
    restart: always
  launchpad:
    image: 'quantrocket/launchpad:1.6.0'
    volumes:
      - 'codeload:/codeload'
    restart: always
  license-service:
    image: 'quantrocket/license-service:1.6.0'
    volumes:
      - 'settings:/etc/opt/quantrocket'
    restart: always
  logspout:
    image: 'quantrocket/logspout:latest'
    volumes:
      - '/var/run/docker.sock:/var/run/docker.sock'
    depends_on:
      - houston
      - flightlog
    command: 'syslog+udp://flightlog:9021,syslog://logs5.papertrailapp.com:47405?filter.name=*houston*'
    restart: always
  master:
    image: 'quantrocket/master:1.6.1'
    volumes:
      - 'db:/var/lib/quantrocket'
      - 'codeload:/codeload'
    depends_on:
      - db
    restart: always
  moonshot:
    image: 'quantrocket/moonshot:1.6.0'
    volumes:
      - 'codeload:/codeload'
    restart: always
  satellite:
    image: 'quantrocket/satellite:1.6.0'
    volumes:
      - 'codeload:/codeload'
    depends_on:
      - codeload
    restart: always
  zipline:
    image: 'quantrocket/zipline:1.6.0'
    volumes:
      - 'codeload:/codeload'
      - 'zipline:/root/.zipline'
    restart: always
